#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 600;
std::vector<std::pair<int,int>> g[1 + nmax];

int solve(int n, int id) {
  std::queue<int> q;
  std::vector<int> seen(1 + n);
  q.push(1);
  seen[1] = 1;
  int steps = 0;
  while(0 < q.size()) {
    int node = q.front();
    q.pop();
    steps++;

    for(int h = 0;h < g[node].size();h++) {
      int to = g[node][h].first;
      if(g[node][h].second != id) {
        if(seen[to] == 0) {
          seen[to] = 1;
          q.push(to);
        }
      }
    }
  }
  return (n == steps);
}

int main() {
  int n, m;
  std::cin >> n >> m;
  for(int i = 1;i <= m; i++) {
    int x, y;
    std::cin >> x >> y;
    g[x].push_back({y, i});
    g[y].push_back({x, i});
  }
  int result = 0;
  for(int i = 1;i <= m; i++)
    result += !solve(n, i);
  std::cout << result;
  return 0;
}
