#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <string>
#include <random>
#include <chrono>
#include <queue>
#include <set>
#include <map>
using namespace std;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
    return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(a)
#endif
using llong = long long;
using uint = unsigned int;
using ullong = unsigned long long;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
const int maxN = 601;

vector<int> nei[maxN];
bool used[maxN];
int tin[maxN], tout[maxN], fup[maxN];

int DFS(int v, int par)
{
    static int time = 0;
    tin[v] = time++;
    fup[v] = 1000'000'000;
    used[v] = true;
    int res = 0;
    for (int to: nei[v]) {
        if (!used[to]) {
            res += DFS(to, v);
            if (fup[to] > tin[v])
                ++res;
        }
        if (to != par)
            if (tin[v] <= tin[to])
                fup[v] = min(fup[v], fup[to]);
            else
                fup[v] = min(fup[v], tin[to]);
    }
    tout[v] = time;
    return res;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    while (m--)
    {
        int u, v;
        cin >> u >> v;
        nei[u].push_back(v);
        nei[v].push_back(u);
    }
    int ans = 0;
    for (int v = 1; v <= n; ++v)
        if (!used[v])
            ans += DFS(v, -1);
    cout << ans;
}
