#include <iostream>
#include <vector>
#include <tuple>

using namespace std;

vector<bool> visited;
vector<vector<pair<int,int>>> adj;
vector<pair<int,int>> roads;

void dfs(int u, int b)
{
    if(visited[u])
        return;
    visited[u] = true;

    for(auto p:adj[u])
        if(p.second != b)
            dfs(p.first, b);
}

int main()
{
    int n,m;
    cin>>n>>m;
    visited = vector<bool>(n,false);
    adj = vector<vector<pair<int,int>>>(n);

    for(int i=0; i<m; i++)
    {
        int a,b;
        cin>>a>>b; a--; b--;
        roads.push_back(make_pair(a,b));
        adj[a].push_back(make_pair(b, i));
        adj[b].push_back(make_pair(a, i));
    }

    int count = 0;
    for(int i=0; i<m; i++)
    {
        for(int j=0; j<n; j++)
            visited[j] = false;
        dfs(roads[i].first, i);
        if(!visited[roads[i].second])
            count++;
    }
    cout<<count<<endl;
}