#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <bitset>
#include <cmath>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <string>
#include <valarray>
#include <vector>
using namespace std;
#define all(x) begin(x), end(x)
#define till(x, n) begin(x), begin(x) + n
#define allr(x) rbegin(x), rend(x)
#define tillr(x, n) rbegin(x), rbegin(x) + n
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
template <typename T>
using lim = numeric_limits<T>;
static constexpr int INF = 1000000000;
static constexpr ll INFl = (ll)1e18;
template <typename T>
void Write(ostream &out, T val) {
  out << val << endl;
}
template <typename T1, typename... T>
void Write(ostream &out, T1 first, T... val) {
  out << first << " ";
  Write(out, val...);
}
template <typename T = int>
T Read(istream &in = cin) {
  T res;
  in >> res;
  return res;
}
template <typename T1 = int, typename T2 = int>
pair<T1, T2> ReadPair(istream &in = cin) {
  T1 a = Read<T1>(in);
  T2 b = Read<T2>(in);
  return make_pair(a, b);
}
template <typename T>
void ReadTuple(istream &in, T &val) {
  val = Read<T>(in);
}
template <typename T1, typename... T>
void ReadTuple(istream &in, T1 &first, T &... other) {
  first = Read<T1>(in);
  ReadTuple(in, other...);
}
template <typename It,
          typename T = typename std::iterator_traits<It>::value_type>
void ReadArray(It begin, It end, istream &in = cin) {
  do {
    *begin = Read<T>(in);
  } while (++begin != end);
}
template <typename It,
          typename T = typename std::iterator_traits<It>::value_type>
void WriteArray(It begin, It end, ostream &out = cout) {
  while (begin != end) {
    out << *begin << " \n"[++begin == end];
  }
}
template <typename T>
istream &operator>>(istream &in, vector<T> &v) {
  ReadArray(begin(v), end(v), in);
  return in;
}
template <typename F, typename S>
istream &operator>>(istream &in, pair<F, S> &p) {
  in >> p.first >> p.second;
  return in;
}
template <typename T>
ostream &operator<<(ostream &out, const vector<T> &v) {
  WriteArray(begin(v), end(v), out);
  return out;
}
template <typename F, typename S>
ostream &operator<<(ostream &out, const pair<F, S> &p) {
  Write(out, p.first, p.second);
  return out;
}

int main() {
  // use this to map stdin/stdout to the corresponding files
  // #define MAPFIO

#if !(defined _DEBUG) && (defined MAPFIO)
  ifstream in("knapsack.in");
  ofstream out("knapsack.out");

#define cin in
#define cout out
#endif

  int k = Read(cin);
  vector<int> ka(k);
  ReadArray(all(ka), cin);

  map<int, int> m;
  for (int ki = 0; ki < k; ki++) {
    for (int ni = 0; ni < ka[ki]; ni++) {
      int a = Read(cin);
      m[a]++;
    }
  }

  bool found = false;
  for (auto p : m) {
    if (p.second == k) {
      found = true;
      Write(cout, p.first);
      break;
    }
  }
  if (!found) Write(cout, 'x');

#if !(defined _DEBUG) && (defined MAPFIO)
  out.close();
  in.close();
#endif
  return 0;
}
