#include <bits/stdc++.h>

const int MAX_N = 600;
const int MAX_M = 2000;

struct Edge {
	int a, b;

	bool blocked;

	int other(int x) {
		return a ^ b ^ x;
	}
} edges[MAX_M];

std::vector<int> graph[1+MAX_N];

int op = 0;
int last[1+MAX_N];

int dfs(int nod) {
	int res = 1;
	last[nod] = op;

	for(auto it: graph[nod]) {
		int son = edges[it].other(nod);
		if(!edges[it].blocked && last[son] < op) {
			res += dfs(son);
		}
	}

	return res;
}

int cnt_comp(int nod) {
	++op;
	return dfs(nod);
}

int main() {
	int n, m;
	scanf("%d%d", &n, &m);

	for(int i = 0; i < m; ++i) {
		scanf("%d%d", &edges[i].a, &edges[i].b);
		graph[edges[i].a].push_back(i);
		graph[edges[i].b].push_back(i);
	}

	int res = 0;

	for(int i = 1; i <= m; ++i) {
		int big_size = cnt_comp(edges[i].a);
		edges[i].blocked = true;
		
		int small_size = cnt_comp(edges[i].a);

		if(big_size != small_size)
			++res;

		edges[i].blocked = false;
	}

	printf("%d", res);
	return 0;
}
