#include <iostream>
#include <vector>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 6e2 + 5, MMAX = 2e3 + 5;

int N, M;

vector < PII > G[NMAX];

bool Sel[NMAX];

PII Edges[MMAX];

static inline void Load ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int X = 0, Y = 0;
        cin >> X >> Y;

        G[X].push_back({Y, i}), G[Y].push_back({X, i});

        Edges[i] = {X, Y};
    }

    return;
}

static inline void Reset ()
{
    for(int i = 1; i <= N; ++i)
        Sel[i] = 0;

    return;
}

static inline void DFS (int Node, int Not)
{
    Sel[Node] = 1;

    for(auto it : G[Node])
        if(it.second != Not)
            if(!Sel[it.first])
                DFS(it.first, Not);

    return;
}

static inline bool Critic (int Id)
{
    Reset();

    DFS(Edges[Id].first, Id);

    return !Sel[Edges[Id].second];
}

static inline void Solve ()
{
    int ans = 0;

    for(int i = 1; i <= M; ++i)
        if(Critic(i))
            ++ans;

    cout << ans << '\n';

    return;
}

int main()
{
    Load();

    Solve();

    return 0;
}
