#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

const int KMAX = 1e3 + 5;
const int NMAX = 5e5 + 5;

int K;

int N[KMAX];

int V[NMAX];
int List[NMAX];

bool Active[NMAX];

namespace InParser
{
static const int BSIZE = (1 << 16);

static int pos = (BSIZE - 1);
static char buff[BSIZE];

static inline char Char ()
{
    ++pos;

    if(pos == BSIZE)
    {
        pos = 0;

        int n = fread(buff, 1, BSIZE, stdin);

        if(n != BSIZE)
            for(int i = n; i < BSIZE; ++i)
                buff[i] = 0;
    }

    return buff[pos];
}

inline int Int ()
{
    int ans = 0, sign = 1;

    for( ; ; )
    {
        char Ch = Char();

        if(Ch == '-')
        {
            sign = -1;

            break;
        }

        if(Ch >= '0' && Ch <= '9')
        {
            ans = (int)(Ch - '0');

            break;
        }
    }

    for( ; ; )
    {
        char Ch = Char();

        if(Ch >= '0' && Ch <= '9')
            ans = ans * 10 + (int)(Ch - '0');
        else break;
    }

    return (ans * sign);
}
};

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    /*
    freopen("1.in", "r", stdin);
    freopen("1.out", "w", stdout);
    */

    K = InParser :: Int();

    for(int i = 1; i <= K; ++i)
        N[i] = InParser :: Int();

    for(int i = 1; i <= K; ++i)
    {
        for(int j = 1; j <= N[i]; ++j)
            V[j] = InParser :: Int();

        sort(V + 1, V + N[i] + 1);

        if(i == 1)
        {
            List[0] = 0;

            List[++List[0]] = V[1], Active[List[0]] = 1;

            for(int j = 2; j <= N[i]; ++j)
                if(V[j] != V[j - 1])
                    List[++List[0]] = V[j], Active[List[0]] = 1;

            continue;
        }

        int p = 1;

        for(int j = 1; j <= List[0]; ++j)
        {
            while(p <= N[i] && V[p] < List[j])
                ++p;

            if(V[p] == List[j])
            {
                while(p <= N[i] && V[p] == List[j])
                    ++p;

                continue;
            }

            if(p <= N[i] && V[p] == List[j])
                continue;
            else Active[j] = 0;
        }

        int copie = List[0];

        List[0] = 0;
        for(int j = 1; j <= copie; ++j)
            if(Active[j])
                List[++List[0]] = List[j], Active[List[0]] = 1;
    }

    if(List[0])
        printf("%d\n", List[1]);
    else printf("x\n");

    return 0;
}
