//
//  main.cpp
//  $%U%$
//
//  Created by Panagiotis Chadjicostas on $%Y%$/$%M%$/$%Y%$
//  Copyright © $%Y%$ Panagiotis Hadjicostas. All rights reserved.
//

#include <iostream>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iterator>
#include <limits>
#include <list>
#include <cstring>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <vector>
#include <unordered_map>

using namespace std;

typedef long long  ll;
#define fo(i,a,b) for(int i = a;i <= b;i++)
#define f(i,b) for(int i=0;i<b;i++)
const ll MOD=ll(1e9)+7;

int n; // number of nodes
vector<vector<int> >  adj; // adjacency list of graph

vector<bool> visited;
vector<int> tin, low;
int timer;
ll counterans=0;
void dfs(int v, int p = -1) {
    visited[v] = true;
    tin[v] = low[v] = timer++;
    for (int to : adj[v]) {
        if (to == p) continue;
        if (visited[to]) {
            low[v] = min(low[v], tin[to]);
        } else {
            dfs(to, v);
            low[v] = min(low[v], low[to]);
            if (low[to] > tin[v])
                counterans++;
        }
    }
}

void find_bridges() {
    timer = 0;
    visited.assign(n, false);
    tin.assign(n, -1);
    low.assign(n, -1);
    for (int i = 0; i < n; ++i) {
        if (!visited[i])
            dfs(i);
    }
}

void solve(){
    ll m;
    cin>>n>>m;
    n++;
    for(ll i=0;i<m;i++){
        ll x,y;cin>>x>>y;

        adj[x].push_back(y);
        adj[y].push_back(x);
    }
    find_bridges();
    cout<<counterans<<endl;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t=1;//cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}
