#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 601;
vector<int> edges[MAX_N];

int UF[MAX_N];
int lvl[MAX_N];

int root(int x) {
    return UF[x]? UF[x] = root(UF[x]) : x;
}

void unite(int x, int y) {
    x = root(x);
    y = root(y);

    if (x != y)
        UF[x] = y;
}

int dfs(int u, int p = 0) {
    lvl[u] = lvl[p] + 1;
    int lmin = lvl[u];

    for (int v : edges[u]) {
        if (v == p)
            continue;

        if (!lvl[v]) {
            int l = dfs(v, u);
            if (l <= lvl[u])
                unite(u, v);
            lmin = min(lmin, l);
        } else {
            lmin = min(lmin, lvl[v]);
        }
    }

    return lmin;
}


int main() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }

    int ans = 0;
    for (int i = 1; i <= n; i++)
        if (!lvl[i]) {
            dfs(i);
            ans--;
        }

    for (int i = 1; i <= n; i++)
        ans += !UF[i];
    cout << ans;

    return 0;
}
