#include <iostream>
#include <vector>
#include <algorithm>
#include <iterator>

#define ENDL '\n'

namespace {
template<class T>
auto intersect(std::vector<T>& set_a, std::vector<T>& set_b) {
	std::vector<T> res;
	std::set_intersection(set_a.begin(), set_a.end(), set_b.begin(), set_b.end(), std::back_inserter(res));
	
	return res;
}
} // namespace

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	std::cout.tie(nullptr);
	
	int k;
	std::cin >> k;
	
	switch (k) {
	case 0:
		std::cout << 'x' << ENDL;
		
		return 0;
	case 1:
		int foo;
		
		std::cin >> foo >> foo;
		std::cout << foo << ENDL;
		
		return 0;
	default:
		break;
	}
	
	std::vector<std::vector<int>> sequences;
	sequences.resize(k);
	
	for (auto& sequence : sequences) {
		int n;
		std::cin >> n;
		
		sequence.resize(n);
	}
	
	for (auto& sequence : sequences) {
		for (auto& val : sequence) {
			std::cin >> val;
		}
		
		std::sort(sequence.begin(), sequence.end());
	}
	
	auto res = intersect(sequences[0], sequences[1]);
	for (auto i = 2; i < k; ++i) {
		res = intersect(res, sequences[i]);
	}
	
	if (res.empty()) {
		std::cout << 'x' << ENDL;
	} else {
		std::cout << res.front() << ENDL;
	}
	
	/* for (auto& sequence : sequences) {
		std::copy(sequence.begin(), sequence.end(), std::ostream_iterator<int>(std::cout, " "));
		std::cout << std::endl;
	} */

	return 0;
}