#include <functional>
#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 1e5 + 5;
const int MAXM = 1e8 + 5;

int n, m;
vector <int> graph[MAXN];

bool used[MAXN];
int depth[MAXN];

int dp[MAXN];
int answer = 0;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    function<void(int, int, int)> DFS = [&](int x, int last, int level)
    {
        used[x] = true;
        depth[x] = level;

        for(int y: graph[x])
        {
            if(y==last) continue;

            if(used[y]==false)
            {
                DFS(y, x, level+1);
                dp[x] += dp[y];
            }
            else
            {
                if(depth[y]<depth[x]) dp[x]++;
                else dp[x]--;
            }
        }

        if(last!=-1 && dp[x]==0) answer++;
    };

    cin >> n >> m;
    for(int i = 0;i<m;i++)
    {
        int u, v;
        cin >> u >> v;

        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    for(int x = 1;x<=n;x++)
    {
        if(used[x]==false)
            DFS(x, -1, 1);
    }
    cout << answer << '\n';
}
