#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m;
vector<vector<int>> graph;

void read() {
    cin >> n >> m;

    graph.resize(n + 1);
    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;

        graph[from].emplace_back(to);
        graph[to].emplace_back(from);
    }
}

int dfsTime = 0, answer = 0;
vector<int> low, disc;

void dfs(int node, int parent = -1) {
    low[node] = disc[node] = ++dfsTime;

    for (int adjNode : graph[node]) {
        if (disc[adjNode] == -1) {
            dfs(adjNode, node);

            low[node] = min(low[node], low[adjNode]);

            if (low[adjNode] > disc[node]) {
                answer++;
            }
        } else if (adjNode != parent) {
            low[node] = min(low[node], disc[adjNode]);
        }
    }
}

void solve() {
    low.resize(n + 1);
    disc.resize(n + 1, -1);

    for (int i = 1; i <= n; i++) {
        if (disc[i] == -1) {
            dfs(i);
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
